diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-ppdu.cc ns-3.43/src/wifi/model/wifi-ppdu.cc
--- ns-3.42/src/wifi/model/wifi-ppdu.cc	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-ppdu.cc	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2019 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Rediet <getachew.redieteab@orange.com>
  */
@@ -24,6 +13,49 @@
 
 #include "ns3/log.h"
 
+namespace
+{
+/**
+ * Get the center frequency of each segment covered by the provided channel width. If the specified
+ * channel width is contained in a single frequency segment, a single center frequency is returned.
+ * If the specified channel width is spread over multiple frequency segments (e.g. 160 MHz if
+ * operating channel is 80+80MHz), multiple center frequencies are returned.
+ *
+ * \param channel the operating channel of the PHY
+ * \param channelWidth the channel width
+ * \return the center frequency of each segment covered by the given width
+ */
+std::vector<ns3::MHz_u>
+GetChannelCenterFrequenciesPerSegment(const ns3::WifiPhyOperatingChannel& channel,
+                                      ns3::MHz_u channelWidth)
+{
+    if (!channel.IsSet())
+    {
+        return {};
+    }
+    std::vector<ns3::MHz_u> freqs{};
+    const auto width = std::min(channelWidth, channel.GetWidth(0));
+    const auto primarySegmentIndex = channel.GetPrimarySegmentIndex(width);
+    const auto secondarySegmentIndex = channel.GetSecondarySegmentIndex(width);
+    const auto primaryIndex = channel.GetPrimaryChannelIndex(channelWidth);
+    const auto segmentIndices =
+        ((channel.GetNSegments() < 2) || (channelWidth <= channel.GetWidth(primarySegmentIndex)))
+            ? std::vector<uint8_t>{primarySegmentIndex}
+            : std::vector<uint8_t>{primarySegmentIndex, secondarySegmentIndex};
+    for (auto segmentIndex : segmentIndices)
+    {
+        const auto segmentFrequency = channel.GetFrequency(segmentIndex);
+        const auto segmentWidth = channel.GetWidth(segmentIndex);
+        // segmentOffset has to be an (unsigned) integer to ensure correct calculation
+        const uint8_t segmentOffset = (primarySegmentIndex * (segmentWidth / channelWidth));
+        const auto freq =
+            segmentFrequency - (segmentWidth / 2.) + (primaryIndex - segmentOffset + 0.5) * width;
+        freqs.push_back(freq);
+    }
+    return freqs;
+}
+} // namespace
+
 namespace ns3
 {
 
@@ -35,9 +67,7 @@
                    uint64_t uid /* = UINT64_MAX */)
     : m_preamble(txVector.GetPreambleType()),
       m_modulation(txVector.IsValid() ? txVector.GetModulationClass() : WIFI_MOD_CLASS_UNKNOWN),
-      m_txCenterFreq(channel.IsSet()
-                         ? channel.GetPrimaryChannelCenterFrequency(txVector.GetChannelWidth())
-                         : 0),
+      m_txCenterFreqs(GetChannelCenterFrequenciesPerSegment(channel, txVector.GetChannelWidth())),
       m_uid(uid),
       m_txVector(txVector),
       m_operatingChannel(channel),
@@ -57,9 +87,7 @@
     : m_preamble(txVector.GetPreambleType()),
       m_modulation(txVector.IsValid() ? txVector.GetMode(psdus.begin()->first).GetModulationClass()
                                       : WIFI_MOD_CLASS_UNKNOWN),
-      m_txCenterFreq(channel.IsSet()
-                         ? channel.GetPrimaryChannelCenterFrequency(txVector.GetChannelWidth())
-                         : 0),
+      m_txCenterFreqs(GetChannelCenterFrequenciesPerSegment(channel, txVector.GetChannelWidth())),
       m_uid(uid),
       m_txVector(txVector),
       m_operatingChannel(channel),
@@ -142,54 +170,63 @@
     return m_modulation;
 }
 
-uint16_t
+MHz_u
 WifiPpdu::GetTxChannelWidth() const
 {
     return m_txChannelWidth;
 }
 
-uint16_t
-WifiPpdu::GetTxCenterFreq() const
+std::vector<MHz_u>
+WifiPpdu::GetTxCenterFreqs() const
 {
-    return m_txCenterFreq;
+    return m_txCenterFreqs;
 }
 
 bool
-WifiPpdu::DoesOverlapChannel(uint16_t minFreq, uint16_t maxFreq) const
+WifiPpdu::DoesOverlapChannel(MHz_u minFreq, MHz_u maxFreq) const
 {
-    NS_LOG_FUNCTION(this << m_txCenterFreq << minFreq << maxFreq);
-    uint16_t minTxFreq = m_txCenterFreq - m_txChannelWidth / 2;
-    uint16_t maxTxFreq = m_txCenterFreq + m_txChannelWidth / 2;
-    /**
-     * The PPDU does not overlap the channel in two cases.
-     *
-     * First non-overlapping case:
-     *
-     *                                        ┌─────────┐
-     *                                PPDU    │ Nominal │
-     *                                        │  Band   │
-     *                                        └─────────┘
-     *                                   minTxFreq   maxTxFreq
-     *
-     *       minFreq                       maxFreq
-     *         ┌──────────────────────────────┐
-     *         │           Channel            │
-     *         └──────────────────────────────┘
-     *
-     * Second non-overlapping case:
-     *
-     *         ┌─────────┐
-     * PPDU    │ Nominal │
-     *         │  Band   │
-     *         └─────────┘
-     *    minTxFreq   maxTxFreq
-     *
-     *                 minFreq                       maxFreq
-     *                   ┌──────────────────────────────┐
-     *                   │           Channel            │
-     *                   └──────────────────────────────┘
-     */
-    return minTxFreq < maxFreq && maxTxFreq > minFreq;
+    NS_LOG_FUNCTION(this << minFreq << maxFreq);
+    // all segments have the same width
+    const MHz_u txChannelWidth = (m_txChannelWidth / m_txCenterFreqs.size());
+    for (auto txCenterFreq : m_txCenterFreqs)
+    {
+        const auto minTxFreq = txCenterFreq - txChannelWidth / 2;
+        const auto maxTxFreq = txCenterFreq + txChannelWidth / 2;
+        /**
+         * The PPDU does not overlap the channel in two cases.
+         *
+         * First non-overlapping case:
+         *
+         *                                        ┌─────────┐
+         *                                PPDU    │ Nominal │
+         *                                        │  Band   │
+         *                                        └─────────┘
+         *                                   minTxFreq   maxTxFreq
+         *
+         *       minFreq                       maxFreq
+         *         ┌──────────────────────────────┐
+         *         │           Channel            │
+         *         └──────────────────────────────┘
+         *
+         * Second non-overlapping case:
+         *
+         *         ┌─────────┐
+         * PPDU    │ Nominal │
+         *         │  Band   │
+         *         └─────────┘
+         *    minTxFreq   maxTxFreq
+         *
+         *                 minFreq                       maxFreq
+         *                   ┌──────────────────────────────┐
+         *                   │           Channel            │
+         *                   └──────────────────────────────┘
+         */
+        if ((minTxFreq < maxFreq) && (maxTxFreq > minFreq))
+        {
+            return true;
+        }
+    }
+    return false;
 }
 
 uint64_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-ppdu.h ns-3.43/src/wifi/model/wifi-ppdu.h
--- ns-3.42/src/wifi/model/wifi-ppdu.h	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-ppdu.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2019 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Rediet <getachew.redieteab@orange.com>
  */
@@ -27,6 +16,7 @@
 #include <list>
 #include <optional>
 #include <unordered_map>
+#include <vector>
 
 /**
  * \file
@@ -132,23 +122,23 @@
      * Get the channel width over which the PPDU will effectively be
      * transmitted.
      *
-     * \return the effective channel width (in MHz) used for the tranmsission
+     * \return the effective channel width used for the tranmsission
      */
-    virtual uint16_t GetTxChannelWidth() const;
+    virtual MHz_u GetTxChannelWidth() const;
 
     /**
-     * \return the center frequency (MHz) used for the transmission of this PPDU
+     * \return the center frequency per segment used for the transmission of this PPDU
      */
-    uint16_t GetTxCenterFreq() const;
+    std::vector<MHz_u> GetTxCenterFreqs() const;
 
     /**
      * Check whether the given PPDU overlaps a given channel.
      *
-     * \param minFreq the minimum frequency (MHz) of the channel
-     * \param maxFreq the maximum frequency (MHz) of the channel
+     * \param minFreq the minimum frequency of the channel
+     * \param maxFreq the maximum frequency of the channel
      * \return true if this PPDU overlaps the channel, false otherwise
      */
-    bool DoesOverlapChannel(uint16_t minFreq, uint16_t maxFreq) const;
+    bool DoesOverlapChannel(MHz_u minFreq, MHz_u maxFreq) const;
 
     /**
      * Get the modulation used for the PPDU.
@@ -199,11 +189,12 @@
      */
     virtual std::string PrintPayload() const;
 
-    WifiPreamble m_preamble;          //!< the PHY preamble
-    WifiModulationClass m_modulation; //!< the modulation used for the transmission of this PPDU
-    WifiConstPsduMap m_psdus;         //!< the PSDUs contained in this PPDU
-    uint16_t m_txCenterFreq; //!< the center frequency (MHz) used for the transmission of this PPDU
-    uint64_t m_uid;          //!< the unique ID of this PPDU
+    WifiPreamble m_preamble;            //!< the PHY preamble
+    WifiModulationClass m_modulation;   //!< the modulation used for the transmission of this PPDU
+    WifiConstPsduMap m_psdus;           //!< the PSDUs contained in this PPDU
+    std::vector<MHz_u> m_txCenterFreqs; //!< the center frequency per segment used for the
+                                        //!< transmission of this PPDU
+    uint64_t m_uid;                     //!< the unique ID of this PPDU
     mutable std::optional<WifiTxVector>
         m_txVector; //!< the TXVECTOR at TX PHY or the reconstructed TXVECTOR at RX PHY (or
                     //!< std::nullopt if TXVECTOR has not been reconstructed yet)
@@ -223,12 +214,12 @@
                             //!< returned WifiTxVector)
     uint8_t m_txAntennas;   //!< the number of antennas used to transmit this PPDU
 
-    uint16_t m_txChannelWidth; /**< The channel width (MHz) used for the transmission of this
+    MHz_u m_txChannelWidth; /**< The channel width used for the transmission of this
                                          PPDU. This has to be stored since channel width can not
                                          always be obtained from the PHY headers, especially for
                                          non-HT PPDU, since we do not sense the spectrum to
                                          determine the occupied channel width for simplicity. */
-};                             // class WifiPpdu
+};                          // class WifiPpdu
 
 /**
  * \brief Stream insertion operator.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-protection.cc ns-3.43/src/wifi/model/wifi-protection.cc
--- ns-3.42/src/wifi/model/wifi-protection.cc	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-protection.cc	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-protection.h ns-3.43/src/wifi/model/wifi-protection.h
--- ns-3.42/src/wifi/model/wifi-protection.h	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-protection.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-protection-manager.cc ns-3.43/src/wifi/model/wifi-protection-manager.cc
--- ns-3.42/src/wifi/model/wifi-protection-manager.cc	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-protection-manager.cc	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -80,7 +69,7 @@
 
 void
 WifiProtectionManager::AddUserInfoToMuRts(CtrlTriggerHeader& muRts,
-                                          uint16_t txWidth,
+                                          MHz_u txWidth,
                                           const Mac48Address& receiver) const
 {
     NS_LOG_FUNCTION(this << muRts << txWidth << receiver);
@@ -91,16 +80,17 @@
     auto apMac = StaticCast<ApWifiMac>(m_mac);
     ui.SetAid12(apMac->GetAssociationId(receiver, m_linkId));
 
-    const uint16_t ctsTxWidth =
+    const auto ctsTxWidth =
         std::min(txWidth, GetWifiRemoteStationManager()->GetChannelWidthSupported(receiver));
     auto phy = m_mac->GetWifiPhy(m_linkId);
     std::size_t primaryIdx = phy->GetOperatingChannel().GetPrimaryChannelIndex(ctsTxWidth);
-    if (phy->GetChannelWidth() == 160 && ctsTxWidth <= 40 && primaryIdx >= 80 / ctsTxWidth)
+    std::size_t idx80MHz = 80 / ctsTxWidth;
+    if ((phy->GetChannelWidth() == 160) && (ctsTxWidth <= 40) && (primaryIdx >= idx80MHz))
     {
         // the primary80 is in the higher part of the 160 MHz channel
         primaryIdx -= 80 / ctsTxWidth;
     }
-    switch (ctsTxWidth)
+    switch (static_cast<uint16_t>(ctsTxWidth))
     {
     case 20:
         ui.SetMuRtsRuAllocation(61 + primaryIdx);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-protection-manager.h ns-3.43/src/wifi/model/wifi-protection-manager.h
--- ns-3.42/src/wifi/model/wifi-protection-manager.h	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-protection-manager.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -110,7 +99,7 @@
      * \param receiver the MAC address of the solicited station
      */
     void AddUserInfoToMuRts(CtrlTriggerHeader& muRts,
-                            uint16_t txWidth,
+                            MHz_u txWidth,
                             const Mac48Address& receiver) const;
 
     Ptr<WifiMac> m_mac; //!< MAC which is using this Protection Manager
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-psdu.cc ns-3.43/src/wifi/model/wifi-psdu.cc
--- ns-3.42/src/wifi/model/wifi-psdu.cc	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-psdu.cc	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2019 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-psdu.h ns-3.43/src/wifi/model/wifi-psdu.h
--- ns-3.42/src/wifi/model/wifi-psdu.h	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-psdu.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2019 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
